stages:
  - test
  - deploy

test:
  stage: test
  image: chilio/laravel-dusk-ci:stable
  variables:
    POSTGRES_DB: apuntes_testing
    POSTGRES_USER: apuntes
    POSTGRES_PASSWORD: secret123!
  services:
    - postgres:latest
  cache:
    paths:
      - node_modules/
      - public/
      - vendor/
  script:
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress --no-scripts
    # Copy over testing configuration.
    - cp .env.testing .env

    - configure-laravel
    - start-nginx-ci-project

    # Generate an application key. Re-cache.
    #- php artisan key:generate
    #- php artisan config:cache
    # Run database migrations.
    #- php artisan migrate
    # Run database seeder
    #- php artisan db:seed

    # Run tests
    - ./vendor/phpunit/phpunit/phpunit -v --coverage-text --colors --stderr
    - bash <(curl -s https://codecov.io/bash)
    - chromedriver & php artisan dusk --colors --debug

  artifacts:
    paths:
      - ./storage/logs # for debugging
      - ./tests/Browser/screenshots
      - ./tests/Browser/console
    expire_in: 7 days
    when: always


deploy:
  stage: deploy
  script:
    - sh .gitlab-staging-deploy.sh 
  environment:
    name: staging
  when: manual

